/* ============================================================
 * File  : toolbar_bt2.cpp
 * Author: Stephane Gibault
 * Date  : Sun Feb 4 2007
 * Description :
 *
 * 
 *  (C) 2007 by Stephane Gibault
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#include <QtGui>
#include "toolbar_bt2.h"

toolbar_bt2::toolbar_bt2 ( QWidget * parent )
    : QPushButton(parent)
{
	this->setAttribute(Qt::WA_DeleteOnClose);
        this->setAttribute(Qt::WA_TranslucentBackground, true);
        x=0;
}

void toolbar_bt2::enterEvent ( QEvent * ) 
{
        if ( x == 0 )
        {
            x = this->geometry().x();
            y = this->geometry().y();
            w = this->width();
            h = this->height();
        }

        if ( this->isCheckable() == false && this->isEnabled() == true )
        {
            QPropertyAnimation *animation = new QPropertyAnimation(this, "geometry");
            animation->setDuration(200);
            animation->setStartValue(QRect(x,y,w,h));
            animation->setEndValue(QRect(this->geometry().x()-5,this->geometry().y()-5,this->width()+10,this->height()+10));
            animation->setEasingCurve(QEasingCurve::InOutBack);
            animation->start();
        }
}

void toolbar_bt2::leaveEvent ( QEvent * ) 
{
        if ( this->isCheckable() == false )
        {
            QPropertyAnimation *animation = new QPropertyAnimation(this, "geometry");
            animation->setDuration(200);
            animation->setStartValue(QRect(this->geometry().x(),this->geometry().y(),this->width(),this->height()));
            animation->setEndValue(QRect(x,y,w,h));
            animation->setEasingCurve(QEasingCurve::InOutBack);
            animation->start();
        }
}

// ********************************
// *** DESSIN DU FOND DU WIDGET ***
// ********************************

void toolbar_bt2::paintEvent(QPaintEvent *)
{
	QPainter p;
	p.begin(this);
        if ( this->isCheckable() == false )
        {
            if ( this->isEnabled() == true )
            {
                    p.drawPixmap(0,0,QPixmap(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + ".png").scaled(this->width(),this->height()));
            }
            else
            {
                if ( wl_pix_1.load(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + "3.png") == true )
                {
                    p.drawPixmap(0,0,QPixmap(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + "1.png").scaled(this->width(),this->height()));
                }
                else
                {
                    p.drawPixmap(0,0,QPixmap(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + ".png").scaled(this->width(),this->height()));
                }
            }
        }
        else
        {
            if ( this->isEnabled() == true )
            {
                if ( this->isChecked() == true )
                {
                    p.drawPixmap(0,0,QPixmap(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + "2.png").scaled(this->width(),this->height()));
                }
                else
                {
                    p.drawPixmap(0,0,QPixmap(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + ".png").scaled(this->width(),this->height()));
                }
            }
            else
            {
                p.drawPixmap(0,0,QPixmap(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + "3.png").scaled(this->width(),this->height()));
            }
        }
	p.end();
}

